# HSPTV MIDI Driver

## 概要
HSPTV用アプリケーションで自前のMIDI BGMを演奏するためのモジュールです。
このモジュールは単体で、start.ax生成時のファイルのサイズを約1000バイトほど使用します。(6000バイト制限きっつい...)

## 動作環境
* HSP3.4以上
* Windows 98以上(Windows XP以上を推奨)
* 1つのMIDI音源(Windows 98以上ならデフォルトで1つついていますので大丈夫です)

## 命令・関数一覧
* tvmiddrv_init 命令
	- 定義: ` #deffunc tvmididrv_init `
	- midi音源、音色データの初期化を行います。
* tvmiddrv_play 命令
	- 定義: ` #deffunc tvmiddrv_play int ch , var data `
	- chで指定したチャンネルにおいて変数dataの、モジュール変数tickバイト目を取り出し、そのデータに応じて発音します。
* tvmiddrv_tick_next マクロ
	- 定義: ` #define tvmiddrv_tick_next tick@tvmiddrv++ `
	- モジュール変数tickを1大きくします。無限ループ内などでお使いください。waitの時間によってBPMが変わるクソ仕様です。


## 制限
パースが面倒になるし、しかも複雑なことをするとすぐに6000バイトを使い切ってしまいそうなので、機能制限があります。
* 1チャンネルにつき同時発音は1音までです。
* パン、リバーブなどの値は定位です。
* ベロシティの値は127(最大)固定です。
* エクスプレッションの値は4段階で調整可能です。
* 使用できるmidi音源はひとつです。(midiapi側の制限。)多くの環境でMSGSになります。
	* モジュール初期化部に記載しているMIDI音源番号を変更することで違う音源でも鳴らせるようになりますが、配布するhsptvアプリで利用する場合は変更しないでください。
* 途中でエフェクトや音源を変えることはできません。midiapiの改造が必要となり(、その場合はstart.axの容量が大きくなり)ます。
* tick更新処理はメインルーチン側で行います。このためプログラム全体のtpsを変更すると音楽のBPMも変化します。(でもMIDIなので、PSG音源みたいに音程も同時に変化したりはしません。)

## HSPTV MIDI Driver+について
このモジュール(tvmiddrv_plus.as)は、「HSPTV MIDI Driverに1チャンネル、1音ずつパースして送るのがつらい」「曲に変化をつけるコードが面倒」という人のために作られたモジュールです。
曲データを最初に読み込んだら、あとは無限ループから定期的に命令を呼び出すだけで自動的に発音し、曲に変化も自動的に付けられます。
ただしstart.axの占有サイズはさらに大きくなり、1700バイトほどになります。曲データがプレーンテキストなのを考えると、けっこうしんどいです。

## 外部リンク
[HSPTV MIDI Driver 公式マニュアル(未完成、気が向いたら更新)](https://mikatofu31.github.io/selfnote/000_tvmiddrv.html)

---
(C)2018 Mikatofu31
